/* themes-dialog.c generated by valac 0.40.0.6-2c488, the Vala compiler
 * generated from themes-dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2015 Arnaud Bonatti <arnaud.bonatti@gmail.com>
 *
 * This file is part of a GNOME game.
 *
 * This application is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this application. If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define TYPE_THEMES_DIALOG (themes_dialog_get_type ())
#define THEMES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEMES_DIALOG, ThemesDialog))
#define THEMES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEMES_DIALOG, ThemesDialogClass))
#define IS_THEMES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEMES_DIALOG))
#define IS_THEMES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEMES_DIALOG))
#define THEMES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEMES_DIALOG, ThemesDialogClass))

typedef struct _ThemesDialog ThemesDialog;
typedef struct _ThemesDialogClass ThemesDialogClass;
typedef struct _ThemesDialogPrivate ThemesDialogPrivate;

#define TYPE_GAME_VIEW (game_view_get_type ())
#define GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_VIEW, GameView))
#define GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_VIEW, GameViewClass))
#define IS_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_VIEW))
#define IS_GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_VIEW))
#define GAME_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_VIEW, GameViewClass))

typedef struct _GameView GameView;
typedef struct _GameViewClass GameViewClass;
enum  {
	THEMES_DIALOG_0_PROPERTY,
	THEMES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* themes_dialog_properties[THEMES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

struct _ThemesDialog {
	GtkDialog parent_instance;
	ThemesDialogPrivate * priv;
};

struct _ThemesDialogClass {
	GtkDialogClass parent_class;
};

struct _ThemesDialogPrivate {
	GameView* view;
	GtkListBox* listbox;
};

struct _Block4Data {
	int _ref_count_;
	ThemesDialog* self;
	GSettings* settings;
	GameView* view;
};


static gpointer themes_dialog_parent_class = NULL;

GType themes_dialog_get_type (void) G_GNUC_CONST;
GType game_view_get_type (void) G_GNUC_CONST;
#define THEMES_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_THEMES_DIALOG, ThemesDialogPrivate))
#define THEMES_DIALOG_PREFIX "theme-"
ThemesDialog* themes_dialog_new (GSettings* settings,
                                 GameView* view);
ThemesDialog* themes_dialog_construct (GType object_type,
                                       GSettings* settings,
                                       GameView* view);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean themes_dialog_do_not_close (ThemesDialog* self,
                                     GtkWidget* widget,
                                     GdkEventAny* event);
static gboolean _themes_dialog_do_not_close_gtk_widget_delete_event (GtkWidget* _sender,
                                                              GdkEventAny* event,
                                                              gpointer self);
static void ___lambda7_ (Block4Data* _data4_,
                  GtkListBoxRow* row);
void game_view_set_theme (GameView* self,
                          const gchar* value);
const gchar* game_view_get_theme (GameView* self);
static void ____lambda7__gtk_list_box_row_selected (GtkListBox* _sender,
                                             GtkListBoxRow* row,
                                             gpointer self);
static void themes_dialog_finalize (GObject * obj);


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}


static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		ThemesDialog* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->settings);
		_g_object_unref0 (_data4_->view);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}


static gboolean
_themes_dialog_do_not_close_gtk_widget_delete_event (GtkWidget* _sender,
                                                     GdkEventAny* event,
                                                     gpointer self)
{
	gboolean result;
	result = themes_dialog_do_not_close ((ThemesDialog*) self, _sender, event);
	return result;
}


static void
___lambda7_ (Block4Data* _data4_,
             GtkListBoxRow* row)
{
	ThemesDialog* self;
	GtkWidget* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	self = _data4_->self;
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row);
	_tmp1_ = gtk_container_get_children ((GtkContainer*) G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_box_get_type (), GtkBox));
	_tmp2_ = _tmp1_;
	_tmp3_ = g_list_nth_data (_tmp2_, (guint) 2);
	_tmp4_ = gtk_label_get_label (G_TYPE_CHECK_INSTANCE_CAST ((GtkWidget*) _tmp3_, gtk_label_get_type (), GtkLabel));
	_tmp5_ = _tmp4_;
	game_view_set_theme (_data4_->view, _tmp5_);
	_g_list_free0 (_tmp2_);
	_tmp6_ = game_view_get_theme (_data4_->view);
	_tmp7_ = _tmp6_;
	g_settings_set_string (_data4_->settings, "theme", _tmp7_);
	gtk_widget_queue_draw ((GtkWidget*) self);
}


static void
____lambda7__gtk_list_box_row_selected (GtkListBox* _sender,
                                        GtkListBoxRow* row,
                                        gpointer self)
{
	___lambda7_ (self, row);
}


ThemesDialog*
themes_dialog_construct (GType object_type,
                         GSettings* settings,
                         GameView* view)
{
	ThemesDialog * self = NULL;
	Block4Data* _data4_;
	GSettings* _tmp0_;
	GameView* _tmp1_;
	gint _tmp2_ = 0;
	GtkSettings* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GameView* _tmp6_;
	GDir* dir = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (settings != NULL, NULL);
	g_return_val_if_fail (view != NULL, NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (settings);
	_g_object_unref0 (_data4_->settings);
	_data4_->settings = _tmp0_;
	_tmp1_ = _g_object_ref0 (view);
	_g_object_unref0 (_data4_->view);
	_data4_->view = _tmp1_;
	_tmp3_ = gtk_settings_get_default ();
	g_object_get (_tmp3_, "gtk-dialogs-use-header", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		_tmp2_ = 1;
	} else {
		_tmp2_ = 0;
	}
	self = (ThemesDialog*) g_object_new (object_type, "use-header-bar", _tmp2_, NULL);
	_data4_->self = g_object_ref (self);
	_tmp6_ = _g_object_ref0 (_data4_->view);
	_g_object_unref0 (self->priv->view);
	self->priv->view = _tmp6_;
	g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) _themes_dialog_do_not_close_gtk_widget_delete_event, self, 0);
	{
		GDir* _tmp7_ = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GDir* _tmp10_;
		GDir* _tmp11_;
		GDir* _tmp12_;
		GtkListBox* _tmp60_;
		_tmp8_ = g_build_filename (DATA_DIRECTORY, "themes", "key", NULL);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_dir_open (_tmp9_, (guint) 0, &_inner_error_);
		_tmp11_ = _tmp10_;
		_g_free0 (_tmp9_);
		_tmp7_ = _tmp11_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch6_g_file_error;
			}
			_g_dir_close0 (dir);
			block4_data_unref (_data4_);
			_data4_ = NULL;
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp12_ = _tmp7_;
		_tmp7_ = NULL;
		_g_dir_close0 (dir);
		dir = _tmp12_;
		while (TRUE) {
			gchar* filename = NULL;
			GDir* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* path = NULL;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			GKeyFile* key = NULL;
			GKeyFile* _tmp19_;
			gchar* name = NULL;
			GtkListBoxRow* row = NULL;
			GtkListBoxRow* _tmp28_;
			GtkListBoxRow* _tmp29_;
			GtkListBoxRow* _tmp30_;
			GtkBox* box = NULL;
			GtkBox* _tmp31_;
			GtkBox* _tmp32_;
			GtkImage* img = NULL;
			GtkImage* _tmp33_;
			GtkImage* _tmp34_;
			GtkImage* _tmp35_;
			GtkImage* _tmp36_;
			GtkLabel* lbl = NULL;
			const gchar* _tmp37_;
			GtkLabel* _tmp38_;
			GtkLabel* _tmp39_;
			GtkLabel* _tmp40_;
			GtkLabel* data = NULL;
			const gchar* _tmp41_;
			GtkLabel* _tmp42_;
			GtkLabel* _tmp43_;
			GtkBox* _tmp44_;
			GtkImage* _tmp45_;
			GtkBox* _tmp46_;
			GtkLabel* _tmp47_;
			GtkBox* _tmp48_;
			GtkLabel* _tmp49_;
			GtkListBoxRow* _tmp50_;
			GtkBox* _tmp51_;
			GtkListBox* _tmp52_;
			GtkListBoxRow* _tmp53_;
			const gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gboolean _tmp57_;
			_tmp13_ = dir;
			_tmp14_ = g_dir_read_name (_tmp13_);
			_tmp15_ = g_strdup (_tmp14_);
			filename = _tmp15_;
			_tmp16_ = filename;
			if (_tmp16_ == NULL) {
				_g_free0 (filename);
				break;
			}
			_tmp17_ = filename;
			_tmp18_ = g_build_filename (DATA_DIRECTORY, "themes", "key", _tmp17_, NULL);
			path = _tmp18_;
			_tmp19_ = g_key_file_new ();
			key = _tmp19_;
			{
				GKeyFile* _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_ = NULL;
				GKeyFile* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				_tmp20_ = key;
				_tmp21_ = path;
				g_key_file_load_from_file (_tmp20_, _tmp21_, G_KEY_FILE_NONE, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					if (_inner_error_->domain == G_KEY_FILE_ERROR) {
						goto __catch7_g_key_file_error;
					}
					goto __finally7;
				}
				_tmp23_ = key;
				_tmp24_ = g_key_file_get_locale_string (_tmp23_, "Theme", "Name", NULL, &_inner_error_);
				_tmp22_ = _tmp24_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					if (_inner_error_->domain == G_KEY_FILE_ERROR) {
						goto __catch7_g_key_file_error;
					}
					_g_free0 (name);
					_g_key_file_unref0 (key);
					_g_free0 (path);
					_g_free0 (filename);
					_g_dir_close0 (_tmp7_);
					_g_dir_close0 (dir);
					block4_data_unref (_data4_);
					_data4_ = NULL;
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
				_tmp25_ = _tmp22_;
				_tmp22_ = NULL;
				_g_free0 (name);
				name = _tmp25_;
				_g_free0 (_tmp22_);
			}
			goto __finally7;
			__catch7_g_key_file_error:
			{
				GError* e = NULL;
				GError* _tmp26_;
				const gchar* _tmp27_;
				e = _inner_error_;
				_inner_error_ = NULL;
				_tmp26_ = e;
				_tmp27_ = _tmp26_->message;
				g_warning ("themes-dialog.vala:60: oops: %s", _tmp27_);
				_g_error_free0 (e);
				_g_free0 (name);
				_g_key_file_unref0 (key);
				_g_free0 (path);
				_g_free0 (filename);
				continue;
			}
			__finally7:
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_free0 (name);
				_g_key_file_unref0 (key);
				_g_free0 (path);
				_g_free0 (filename);
				_g_dir_close0 (_tmp7_);
				if (_inner_error_->domain == G_FILE_ERROR) {
					goto __catch6_g_file_error;
				}
				_g_free0 (name);
				_g_key_file_unref0 (key);
				_g_free0 (path);
				_g_free0 (filename);
				_g_dir_close0 (_tmp7_);
				_g_dir_close0 (dir);
				block4_data_unref (_data4_);
				_data4_ = NULL;
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_tmp28_ = (GtkListBoxRow*) gtk_list_box_row_new ();
			g_object_ref_sink (_tmp28_);
			row = _tmp28_;
			_tmp29_ = row;
			gtk_widget_set_visible ((GtkWidget*) _tmp29_, TRUE);
			_tmp30_ = row;
			g_object_set ((GtkWidget*) _tmp30_, "height-request", 50, NULL);
			_tmp31_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
			g_object_ref_sink (_tmp31_);
			box = _tmp31_;
			_tmp32_ = box;
			gtk_widget_set_visible ((GtkWidget*) _tmp32_, TRUE);
			_tmp33_ = (GtkImage*) gtk_image_new ();
			g_object_ref_sink (_tmp33_);
			img = _tmp33_;
			_tmp34_ = img;
			gtk_widget_set_visible ((GtkWidget*) _tmp34_, TRUE);
			_tmp35_ = img;
			g_object_set ((GtkWidget*) _tmp35_, "width-request", 50, NULL);
			_tmp36_ = img;
			g_object_set (_tmp36_, "icon-name", "object-select-symbolic", NULL);
			_tmp37_ = name;
			_tmp38_ = (GtkLabel*) gtk_label_new (_tmp37_);
			g_object_ref_sink (_tmp38_);
			lbl = _tmp38_;
			_tmp39_ = lbl;
			gtk_widget_set_visible ((GtkWidget*) _tmp39_, TRUE);
			_tmp40_ = lbl;
			gtk_label_set_xalign (_tmp40_, (gfloat) 0);
			_tmp41_ = filename;
			_tmp42_ = (GtkLabel*) gtk_label_new (_tmp41_);
			g_object_ref_sink (_tmp42_);
			data = _tmp42_;
			_tmp43_ = data;
			gtk_widget_set_visible ((GtkWidget*) _tmp43_, FALSE);
			_tmp44_ = box;
			_tmp45_ = img;
			gtk_container_add ((GtkContainer*) _tmp44_, (GtkWidget*) _tmp45_);
			_tmp46_ = box;
			_tmp47_ = lbl;
			gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
			_tmp48_ = box;
			_tmp49_ = data;
			gtk_container_add ((GtkContainer*) _tmp48_, (GtkWidget*) _tmp49_);
			_tmp50_ = row;
			_tmp51_ = box;
			gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
			_tmp52_ = self->priv->listbox;
			_tmp53_ = row;
			gtk_container_add ((GtkContainer*) _tmp52_, (GtkWidget*) _tmp53_);
			_tmp54_ = filename;
			_tmp55_ = g_settings_get_string (_data4_->settings, "theme");
			_tmp56_ = _tmp55_;
			_tmp57_ = g_strcmp0 (_tmp54_, _tmp56_) == 0;
			_g_free0 (_tmp56_);
			if (_tmp57_) {
				GtkListBox* _tmp58_;
				GtkListBoxRow* _tmp59_;
				_tmp58_ = self->priv->listbox;
				_tmp59_ = row;
				gtk_list_box_select_row (_tmp58_, _tmp59_);
			}
			_g_object_unref0 (data);
			_g_object_unref0 (lbl);
			_g_object_unref0 (img);
			_g_object_unref0 (box);
			_g_object_unref0 (row);
			_g_free0 (name);
			_g_key_file_unref0 (key);
			_g_free0 (path);
			_g_free0 (filename);
		}
		_tmp60_ = self->priv->listbox;
		g_signal_connect_data (_tmp60_, "row-selected", (GCallback) ____lambda7__gtk_list_box_row_selected, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
		_g_dir_close0 (_tmp7_);
	}
	goto __finally6;
	__catch6_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp61_;
		const gchar* _tmp62_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp61_ = e;
		_tmp62_ = _tmp61_->message;
		g_warning ("themes-dialog.vala:98: Failed to load themes: %s", _tmp62_);
		_g_error_free0 (e);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_dir_close0 (dir);
		block4_data_unref (_data4_);
		_data4_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_dir_close0 (dir);
	block4_data_unref (_data4_);
	_data4_ = NULL;
	return self;
}


ThemesDialog*
themes_dialog_new (GSettings* settings,
                   GameView* view)
{
	return themes_dialog_construct (TYPE_THEMES_DIALOG, settings, view);
}


static gboolean
themes_dialog_do_not_close (ThemesDialog* self,
                            GtkWidget* widget,
                            GdkEventAny* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	gtk_widget_hide (widget);
	result = TRUE;
	return result;
}


static void
themes_dialog_class_init (ThemesDialogClass * klass)
{
	gint ThemesDialog_private_offset;
	themes_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ThemesDialogPrivate));
	G_OBJECT_CLASS (klass)->finalize = themes_dialog_finalize;
	ThemesDialog_private_offset = g_type_class_get_instance_private_offset (klass);
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/iagno/ui/themes.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "listbox", FALSE, ThemesDialog_private_offset + G_STRUCT_OFFSET (ThemesDialogPrivate, listbox));
}


static void
themes_dialog_instance_init (ThemesDialog * self)
{
	self->priv = THEMES_DIALOG_GET_PRIVATE (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void
themes_dialog_finalize (GObject * obj)
{
	ThemesDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEMES_DIALOG, ThemesDialog);
	_g_object_unref0 (self->priv->view);
	_g_object_unref0 (self->priv->listbox);
	G_OBJECT_CLASS (themes_dialog_parent_class)->finalize (obj);
}


GType
themes_dialog_get_type (void)
{
	static volatile gsize themes_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&themes_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThemesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) themes_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThemesDialog), 0, (GInstanceInitFunc) themes_dialog_instance_init, NULL };
		GType themes_dialog_type_id;
		themes_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "ThemesDialog", &g_define_type_info, 0);
		g_once_init_leave (&themes_dialog_type_id__volatile, themes_dialog_type_id);
	}
	return themes_dialog_type_id__volatile;
}



